'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = parseConfig;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _exists = require('../util/exists');

var _parseArgv = require('./parseArgv');

var _parseArgv2 = _interopRequireDefault(_parseArgv);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultConfig = 'mocha-webpack.opts';

function handleMissingConfig(config) {
  if (config) {
    throw new Error('Options file \'' + config + '\' not found');
  }

  return {};
}

function parseConfig(explicitConfig) {
  var config = explicitConfig || defaultConfig;

  if (!(0, _exists.existsFileSync)(config)) {
    return handleMissingConfig(explicitConfig);
  }

  var argv = _fs2.default.readFileSync(config, 'utf8').replace(/\\\s/g, '%20').split(/\s/).filter(Boolean).map(function (value) {
    return value.replace(/%20/g, ' ');
  });
  var defaultOptions = (0, _parseArgv2.default)(argv, true);
  return defaultOptions;
}